#
# Table structure for table 'tx_air_elements'
#
CREATE TABLE tx_air_elements (
    uid int(11) NOT NULL auto_increment,
    pid int(11) DEFAULT '0' NOT NULL,
	lid int(11) DEFAULT '0' NOT NULL,
	rid int(11) DEFAULT '0' NOT NULL,
	sorting int(11) DEFAULT '0' NOT NULL,	
	
	title varchar(255) DEFAULT '' NOT NULL,
	key_element varchar(255) DEFAULT '' NOT NULL,
	sub_key_element varchar(255) DEFAULT '' NOT NULL,
	type_element varchar(255) DEFAULT '' NOT NULL,
	parent_element int(11) DEFAULT '0' NOT NULL,
	commentary tinytext,
	_system_value_path_ts_file_ text,
	
	# колонка для расчетов для светофора (пока не потребовалось)
	# temp_value_for_semafor varchar(255) DEFAULT '' NOT NULL,
	
    PRIMARY KEY (uid),
    KEY parent (pid)
);



#
# Table structure for table 'tx_air_table_marks'
#
CREATE TABLE tx_air_table_marks (

    uid int(11) NOT NULL auto_increment,
    pid int(11) DEFAULT '0' NOT NULL,
    deleted tinyint(4) DEFAULT '0' NOT NULL,
    hidden tinyint(4) DEFAULT '0' NOT NULL,
	sorting int(11) DEFAULT '0' NOT NULL,
	
	title tinytext,
	bodytext text,
	bodytext_with_rte text,
	string tinytext,
	flexform_value text,
	flexform_ts_config text,
	flexform_ts_config_help text,
	
	image_1 tinytext,
	images text,
	file_1 tinytext,
	files text,
	link_parameter tinytext,
	typoscript_code tinytext,
	
	telem tinytext,
	pelem tinytext,
	pelem_external tinytext,
	
	rte_enabled tinyint(4) DEFAULT '0' NOT NULL,
	
	sys_language_uid int(11) DEFAULT '0' NOT NULL,
	l18n_parent int(11) DEFAULT '0' NOT NULL,
	l18n_diffsource mediumblob NOT NULL,
  
    ______separator______ int(11) DEFAULT '0' NOT NULL, 
    
    PRIMARY KEY (uid),
    KEY parent (pid)
    
);



#
# Table structure for table 'pages'
#
CREATE TABLE pages (
	module varchar(255) DEFAULT '' NOT NULL,
	tx_air_table_page_children_sorting text,
	tx_air_table_allowed_tables text,
	tx_air_table_page_without_css_content_styled tinytext,
	tx_air_table_disable_drag_and_drop_this_page tinytext,
	tx_air_table_page_module_special tinytext
);



#
# Table structure for table 'tt_content'
#
CREATE TABLE tt_content (
	flexform_value text,
	box_rendering_ts_config text,
	box_rendering_ts_config_help text,
	flexform_ts_config text,
	flexform_ts_config_help text
);



#
# Table structure for table 'be_users'
#
CREATE TABLE be_users (
	ext_infoblock_flag_debug_mode int(11) DEFAULT '0' NOT NULL
);



#
# Table structure for table 'sys_file_uploads'
#
CREATE TABLE sys_file_uploads (
	uid int(11) NOT NULL auto_increment,
	pid int(11) DEFAULT '0' NOT NULL,
	# update timestamp of the database record, not the file!
	tstamp int(11) DEFAULT '0' NOT NULL,
	crdate int(11) DEFAULT '0' NOT NULL,
	cruser_id int(11) DEFAULT '0' NOT NULL,
	hidden int(11) DEFAULT '0' NOT NULL,

	# Versioning fields
	t3ver_oid int(11) DEFAULT '0' NOT NULL,
	t3ver_id int(11) DEFAULT '0' NOT NULL,
	t3ver_wsid int(11) DEFAULT '0' NOT NULL,
	t3ver_label varchar(30) DEFAULT '' NOT NULL,
	t3ver_state tinyint(4) DEFAULT '0' NOT NULL,
	t3ver_stage int(11) DEFAULT '0' NOT NULL,
	t3ver_count int(11) DEFAULT '0' NOT NULL,
	t3ver_tstamp int(11) DEFAULT '0' NOT NULL,
	t3ver_move_id int(11) DEFAULT '0' NOT NULL,
	t3_origuid int(11) DEFAULT '0' NOT NULL,

	type varchar(10) DEFAULT '' NOT NULL,
	storage int(11) DEFAULT '0' NOT NULL,
	identifier varchar(512) DEFAULT '' NOT NULL,
	identifier_md5 varchar(512) DEFAULT '' NOT NULL,
	extension varchar(255) DEFAULT '' NOT NULL,
	mime_type varchar(255) DEFAULT '' NOT NULL,
	name tinytext,
	title tinytext,
	sha1 tinytext,
	size int(11) DEFAULT '0' NOT NULL,
	# creation/modification date of the file (not the record!)
	creation_date int(11) DEFAULT '0' NOT NULL,
	modification_date int(11) DEFAULT '0' NOT NULL,
	width int(11) DEFAULT '0' NOT NULL,
	height int(11) DEFAULT '0' NOT NULL,
	description text,
	alternative text,
	file_link tinytext, 
	longdescURL tinytext,
	attachment tinytext,

		# Для tt_content старой версии TYPO3 4.5 (для CType = textpic, image, uploads)
	# for_class_tx_air_table_TCEmainHook_ONLY_TYPO3_4_5_table_name tinytext,
	# for_class_tx_air_table_TCEmainHook_ONLY_TYPO3_4_5_record_id tinytext,
			# Название оставил нейтральным для всех таблиц (это родитель к которому прикреплена картинка)
		parent_table_name varchar(512) DEFAULT '' NOT NULL,
		parent_field_name varchar(512) DEFAULT '' NOT NULL,
		parent_record_uid varchar(512) DEFAULT '' NOT NULL,
	
	sys_language_uid int(11) DEFAULT '0' NOT NULL,
	l18n_parent int(11) DEFAULT '0' NOT NULL,
	l18n_diffsource mediumblob NOT NULL,

	PRIMARY KEY (uid),
	KEY parent (pid),
	KEY t3ver_oid (t3ver_oid,t3ver_wsid),
	KEY sel01 (storage,identifier(20)),
	KEY sha1 (sha1(40))
);


#
# Table structure for table 'tx_air_table_user_help'
#
CREATE TABLE tx_air_table_user_help (
    uid int(11) NOT NULL auto_increment,
    pid int(11) DEFAULT '0' NOT NULL,
    cruser_id int(11) DEFAULT '0' NOT NULL,
    deleted tinyint(4) DEFAULT '0' NOT NULL,
	hidden tinyint(4) DEFAULT '0' NOT NULL,
	sorting int(11) DEFAULT '0' NOT NULL,
	
	title tinytext,
    bodytext text,
	parent_element int(11) DEFAULT '0' NOT NULL,
	
	telem tinytext,
	pelem tinytext,
	pelem_external tinytext,
	
    PRIMARY KEY (uid),
    KEY parent (pid)
);
