<?php

/**
 * Class/Function which offers TCE main hook functions.
 *
 */

require_once(PATH_typo3conf . 'ext/air_table/pbild/class.tcabild_ts.php'); // компилятор генератор накопителей
class tx_air_table_TCEmainHook_generationFlexForm {

	/**
	 * A TCEmain hook to expire old records and add new ones
	 *
	 * @param string $status 'new' (ignoring) or 'update'
	 * @param string $tableName
	 * @param int $recordId
	 * @param array $databaseData
	 * @return void
	 * @todo Expire unique alias cache: how to get the proper timeout value easily here?
	 */
	public function processDatamap_afterDatabaseOperations($status, $tableName, $recordId, array $databaseData) {
		if ($tableName == "tt_content" || $tableName == "tx_air_table_marks") {
			$row = t3lib_befunc::getRecord($tableName, $recordId, "*");
			if ($tableName == "tt_content" && ($row['CType'] == "box" || $row['CType'] == "box_int")) {
				tx_infoblock_user_tcamanipulate_dynamic_compiler_TS::generationFlexForm('tt_content', 'flexform_ts_config'); // генерация гибких форм для таблиц tt_content (коробки)
				$o_flashMessage = t3lib_div::makeInstance(
					't3lib_FlashMessage',
					'Обновление гибкой формы в таблице "tt_content" успешно выпонено!',
					'Обновление гибкой формы',
					t3lib_FlashMessage::OK
				);
				t3lib_FlashMessageQueue::addMessage($o_flashMessage);
			}
			if ($tableName == "tx_air_table_marks" && $row['telem'] == "flexform") {
				tx_infoblock_user_tcamanipulate_dynamic_compiler_TS::generationFlexForm('tx_air_table_marks', 'flexform_ts_config'); // генерация гибких форм для tx_air_table_marks (макеры)
				$o_flashMessage = t3lib_div::makeInstance(
					't3lib_FlashMessage',
					'Обновление гибкой формы в таблице "tx_air_table_marks" успешно выпонено!',
					'Обновление гибкой формы',
					t3lib_FlashMessage::OK
				);
				t3lib_FlashMessageQueue::addMessage($o_flashMessage);
			}
		} else {
			
		}
	}

	/**
	 * Function to set the colPos of an element depending on
	 * whether it is a child of a parent container or not
	 * will set colPos according to availability of the current grid column of an element
	 * 0 = no column at all
	 * -1 = grid element column
	 * -2 = non used elements column
	 * changes are applied to the field array of the parent object by reference
	 *
	 * @param	array           $fieldArray: The array of fields and values that have been saved to the datamap
	 * @param	str             $table: The name of the table the data should be saved to
	 * @param	int             $id: The uid of the page we are currently working on
	 * @param	\t3lib_TCEmain  $parentObj: The parent object that triggered this hook
	 * @return	void
	 *
	 */
	# public function processDatamap_preProcessFieldArray(&$fieldArray, $table, $id, &$parentObj) {
	#	//
	# }

	/**
	 * Function to set the colPos of an element depending on
	 * whether it is a child of a parent container or not
	 * will set colPos according to availability of the current grid column of an element
	 * 0 = no column at all
	 * -1 = grid element column
	 * -2 = non used elements column
	 * changes are applied to the field array of the parent object by reference
	 *
	 * @param	array           $fieldArray: The array of fields and values that have been saved to the datamap
	 * @param	str             $table: The name of the table the data should be saved to
	 * @param	int             $id: The uid of the page we are currently working on
	 * @param	\t3lib_TCEmain  $parentObj: The parent object that triggered this hook
	 * @return	void
	 *
	 */
	# public function processDatamap_postProcessFieldArray($status, $table, $id, &$fieldArray, &$parentObj) {
	#	//
	# }

	/**
	 * Function to process the drag & drop copy action
	 *
	 * @param string            $command: The command to be handled by the command map
	 * @param string            $table: The name of the table we are working on
	 * @param int               $id: The id of the record that is going to be copied
	 * @param string            $value: The value that has been sent with the copy command
	 * @param boolean           $commandIsProcessed: A switch to tell the parent object, if the record has been copied
	 * @param \t3lib_TCEmain    $parentObj: The parent object that triggered this hook
	 * @return	void
	 *
	 */
	# public function processCmdmap($command, $table, $id, $value, &$commandIsProcessed, &$parentObj) {
	#	// 
	# }

}

?>