<?php

/***************************************************************
*  Copyright notice
*
*  (c) 2015 Ivan Litovchenko <i-litovan@yandex.ru>
*  All rights reserved
***************************************************************/

require_once(PATH_site.'typo3/interfaces/interface.backend_toolbaritem.php');
require_once(PATH_typo3conf.'ext/air_table/toolbar/function.include.php'); // доп.функции (размер файла, размер БД и другие)
require_once(PATH_typo3conf.'ext/air_table/pbild/class.tcabild_ts.php'); // включаем класс для создания динам.tca

class tx_infoblock_additionalToolbarIcons implements backend_toolbarItem {

	/**
	 * constructor that receives a back reference to the backend
	 *
	 * @param       TYPO3backend    TYPO3 backend object reference
	 */
	public function __construct(TYPO3backend &$backendReference = NULL) {
		$this->backennd = $backendReference;
		$this->_REL_PATH = t3lib_extMgm::extRelPath('air_table') . "toolbar/";
	}

	/**
	 * checks whether the user has access to this toolbar item
	 *
	 * @return  boolean  true if user has access, false if not
	 */
	public function checkAccess() {
		if (!$GLOBALS['BE_USER']->user['admin']) {
			return false;
		}
		return true;
	}

	/**
	 * renders the toolbar item
	 *
 	 * @return      string  the toolbar item rendered as HTML string
	 */
	public function render() {
		
		// "javascript:top.goToModule('web_WorkspacesWorkspaces');"
		return '
			<a id="iblblocksemaforinformationlink" style="cursor: pointer;" class="toolbar-item">
				<img src="'.$this->_REL_PATH.'icons/ico.png" width="54" height="16" title="t3infoblock" alt="" />
			</a>
			<div id="panelALLwrap" class="toolbar-item-menu" style="border-radius: 0 0 0 10px; width: 250px; display: none; z-index: 1000000 !important; color: white; background: url(../typo3conf/ext/air_table/toolbar/img/bgfon.jpg) left top;">
			<div style="position: relative;">
			<div id="panelFLOATright">
				<div id="wrapPanelRightError" style="display: none; border: red 0px solid;">
					<div id="wrapPanelRightErrorLabel" style="border-top: 1px solid #a5a5a5; border-bottom: 1px solid #a5a5a5; position: relative; background-color: yellow; color: black; line-height: 16px; padding-left: 7px;">Сообщение системы: <img onclick="iblFunction_HideContentErrorMessege();" style="position: absolute; right: 1px; top: 1px; cursor: pointer;" src="'.$this->_REL_PATH.'../toolbar/icons/context-menu/close.png"></div>
					<div id="wrapPanelRightError_wrap" style="overflow: auto !important; border: red 0px solid; padding: 10px; max-height: 300px;"></div>
				</div>
				<div id="wrapPanelRight">
					'.$this->htmlBlockInformation().'
					<div style="border-top: 1px solid #a5a5a5; border-bottom: 1px solid #a5a5a5; background-color: yellow; color: black; line-height: 16px; padding-left: 7px;">
						Функции управления
					</div>
					'.$this->htmlBlockButton().'
				</div>
			</div>
			</div>
			</div>
		';
	}
	
	
	/**
	 * returns additional attributes for the list item in the toolbar
	 *
	 * @return      string          list item HTML attibutes
	 */
	public function getAdditionalAttributes() {
		return ' id="t3infoblock-links-menu" ';
	}
	
	/**
	 * returns html code toolbar
	 * @return      string 
	 */
	public function htmlBlockInformation() {
	
			// Определяем кол-во записей...
		$countBOARD_TABLE_standart 				= countRecordsInTable('tx_air_elements', ' WHERE type_element = "new-infoblock-standart-default" ' ); 
		$countBOARD_TABLE_standart_settings 	= countRecordsInTable('tx_air_elements', ' WHERE type_element = "new-infoblock-standart-settings" ' ); 
		$countBOARD_TABLE_modificationPages 	= countRecordsInTable('tx_air_elements', ' WHERE type_element = "new-infoblock-modification-pages" ' ); 
		$countBOARD_TABLE_modificationTtContent = countRecordsInTable('tx_air_elements', ' WHERE type_element = "new-infoblock-modification-tt_content" ' ); 
		$countBOARD_TABLE_AddColumns 			= countRecordsInTable('tx_air_elements', ' WHERE type_element = "new-add-columns" ' ); 
		$countBOARD_TABLE_system 				= countRecordsInTable('tx_air_elements', ' WHERE type_element = "new-infoblock-system" ' ); 
		
			// Определяем размеры БД, файловой системы
		$countTABLE = information_schema_DB_tableCount(TYPO3_db);
		$sizeDB = humanBytes(information_schema_DB_size( TYPO3_db ));
		$sizeFILES = humanBytes(uf_getDirSize("./../"));
		
			// Получаем кол-во ошибок
		$count_error = file_get_contents (PATH_site . 'typo3temp/error-count.txt');
		$count_error = ( $count_error == null ) ? "?" : $count_error;
		
			// Возвращяем блок контента...
		return '
		<div id="iblblocksemaforinformation" style="border: red 0px solid;">
		<div id="iblblocksemaforinformation_wrap">
			<div id="iblblocksemaforinformation_min">
				<div id="iblblocksemaforinformation_min_wrap" style="border: red 0px solid;">
				<table cellspacing="2" cellpadding="5" width="100%" style="padding-top: 15px;">
				<tr>
					<td align="right" valign="bottom" style="vertical-align: bottom;">
						<br />
						Найдено: '.$count_error.' ошибок<br />
						'. date("d/m/Y H:i:s").'<br />
					</td>
					<td><img src="'.$this->_REL_PATH.'icons/'.$this->line_signal().'.gif" align="right" style=" margin-right: 10px;"></td>
				</tr>
				</table>
				<table cellspacing="2" cellpadding="5" border="0" width="100%" style="padding: 5px;">
				<tr>
					<td width="24" align="center"><img style="padding-top: 4px; "src="'.$this->_REL_PATH.'../toolbar/icons/context-menu/error-icon.png" width="16" height="16"></td>
					<td><input style="width: 100%; height: 20px;" type="submit" value="'.$GLOBALS['LANG']->sL('LLL:EXT:air_table/locallang.xml:toolbar.searchError').'" onclick="iblFunction_iblblocksemaforinformation_scanError(this);"></td>
				</tr>
				<tr>
					<td width="24" align="center"><img style="padding-top: 4px; "src="'.$this->_REL_PATH.'../toolbar/icons/context-menu/reload.png" width="16" height="16"></td>
					<td><input style="width: 100%; height: 20px;" type="submit" value="'.$GLOBALS['LANG']->sL('LLL:EXT:air_table/locallang.xml:toolbar.reloadInformer').'" onclick="iblFunction_iblblocksemaforinformation_reload(this);"></td>
				</tr>
				</table>
				</div>
			</div>
			<div style="border-top: 1px solid #a5a5a5; border-bottom: 1px solid #a5a5a5; background-color: yellow; color: black; line-height: 16px; padding-left: 7px;">В системе зарегестрировано:</div>
			<div style="border: red 0px solid; height: 112px; overflow-y: scroll !important;">
				<table cellspacing="2" cellpadding="5" border="0" width="100%" style="padding: 5px;">
					<tr><td align="center"><img src="'.$this->_REL_PATH.'../res/v3/NEW-PAGE-DOKTYPE.png" width="16" height="16"></td><td>Новых типов/модов страниц</td><td>['.$countBOARD_TABLE_modificationPages.']</td></tr>
					<tr><td align="center"><img src="'.$this->_REL_PATH.'../res/v3/NEW-CONTENT-ELEMENT.png" width="16" height="16"></td><td>Новых элементов контента</td><td>['.$countBOARD_TABLE_modificationTtContent.']</td></tr>
					<tr><td align="center"><img src="'.$this->_REL_PATH.'../res/v3/NEW-TABLE.png" width="16" height="16"></td><td>Накопителей</td><td>['.$countBOARD_TABLE_standart.']</td></tr>
					<tr><td align="center"><img src="'.$this->_REL_PATH.'../res/v3/NEW-TABLE-PROJECT-SETTINGS.png" width="16" height="16"></td><td>Накопителей для настроек</td><td>['.$countBOARD_TABLE_standart_settings.']</td></tr>
					<tr><td align="center"><img src="'.$this->_REL_PATH.'../res/v3/ADD-COLUMN.png" width="16" height="16"></td><td>Добавлений колонок</td><td>['.$countBOARD_TABLE_AddColumns.']</td></tr>
					<tr><td align="center"><img src="'.$this->_REL_PATH.'../res/v3/INDEXING.png" width="16" height="16"></td><td>Накопители синдексации</td><td>[1]</td></tr>
					<tr><td align="center"><img src="'.$this->_REL_PATH.'../res/v3/FAL.png" width="16" height="16"></td><td>Накопители описания файлов</td><td>[1]</td></tr>
				</table>
			</div>
			<div style="border-top: 1px solid #a5a5a5; border-bottom: 1px solid #a5a5a5; background-color: yellow; color: black; line-height: 16px; padding-left: 7px;">Статистические данные:</div>
			<table cellspacing="2" cellpadding="5" border="0" width="100%" style="padding: 5px;">
				<tr><td align="center"><img src="'.$this->_REL_PATH.'../res/skull.png" width="16" height="16"></td><td>Утерянных страниц</td><td>['.countSkullPage().']</td></tr>
				<tr><td width="24" align="center"><img src="'.$this->_REL_PATH.'../res/database_table.png" width="16" height="16"></td><td width="190">Размер БД</td><td nowrap>['.$sizeDB.']</td></tr>
				<tr><td align="center"><img src="'.$this->_REL_PATH.'../res/folderopened_yellow.png" width="16" height="16"></td><td>Размер файлов</td><td nowrap>['.$sizeFILES.']</td></tr>
			</table>
		</div>
		</div>';
	
	}
	
	/**
	 * returns html code debug
	 * @return      string 
	 */
	public function htmlBlockButton(){

			// Узнаем чему равен "флаг на режим отладки" в настрйках UC
		$flag_debug_mode = t3lib_befunc::getRecord('be_users', $GLOBALS['BE_USER']->user['uid'] , "*"); 
		if ($flag_debug_mode['ext_infoblock_flag_debug_mode'] == 1) {
			$inputValue = "Выключить режим отладки"; 
			$imgsrcValue = "bug.png"; 
		}
		else { 
			$inputValue = "Включить режим отладки"; 
			$imgsrcValue = "bug_off.png"; 
		}
	
		return '
		<div id="iblblockpanelInstrument"><div id="iblblockpanelInstrument_wrap">
		
			<table cellspacing="2" cellpadding="5" border="0" width="100%" style="padding: 5px;">
			<tr><td align="center">
				<!--
				<tr>
					<td width="24" align="center"><img style="padding-top: 3px;" src="'.$this->_REL_PATH.'../res/refilesize-in-table-sys_file.png" width="16" height="16"></td>
					<td><input 
					onclick="alert(\'Beta - в случае, если производилась замена файлов через FTP (для таблиц sys_file_uploads);\'); return false;"
					style="width: 100%; height: 19px; margin-bottom: 2px; color: gray; " type="submit" value="Пересчитать размеры файлов"></td>
				</tr>
				-->
				<tr>
					<td width="24" align="center"><img style="padding-top: 3px; "src="'.$this->_REL_PATH.'../toolbar/icons/context-menu/'.$imgsrcValue.'" width="16" height="16"></td>
					<td><input style="width: 100%; height: 19px; margin-bottom:2px;" '.(($GLOBALS['BE_USER']->isAdmin() == false)? 'disabled' : null).' type="submit" value="'.$inputValue.'" onclick="iblFunction_iblbloc_debuggingMode_reload(this);"><br />
				</tr>
				<tr>
					<td width="24" align="center"><img style="padding-top: 2px; "src="'.$this->_REL_PATH.'../toolbar/icons/context-menu/hammer-screwdriver.png" width="16" height="16"></td>
					<td><input style="width: 100%; height: 19px; margin-bottom:2px;" '.(($GLOBALS['BE_USER']->isAdmin() == false)? 'disabled' : null).' type="submit" value="Запустить компилятор" onclick="iblFunction_iblbloc_runTheCompiler_reload(this);"><br />
				</tr>
				
			</td></tr>
			</table>
			
		</div></div>';
	
	}
	
	/**
	 * функция выводит картинку-сфетафор - в зависимости от кол-ва ошибок
	 * @return      string 
	 */
	public function line_signal(){
			
			// Если файла не существует - скорее всего после компиляции, выдаем синий светафор
		if (!file_exists (PATH_site . 'typo3temp/error-count.txt')) {
			return 'line-signal-dwarf-blue';
		
		} else {
		
			// Получаем кол-во ошибок
			$count_error = file_get_contents (PATH_site . 'typo3temp/error-count.txt');
	
			if ($count_error == 0)
			return 'line-signal-80';
			
			elseif ($count_error <= 3)
			return 'line-signal-60';
			
			elseif ($count_error <= 5)
			return 'line-signal-40';
			
			elseif ($count_error <= 7)
			return 'line-signal-35-80';
			
			elseif ($count_error <= 10)
			return 'line-signal-20';
			
			else
			return 'line-signal-0';
		
		}
		
	}
	
}

class tx_infoblock_additionalToolbarIcons_ajax {

	/**
	 * renders the toolbar item
	 *
 	 * @return      string  the toolbar item rendered as HTML string
	 */
	public function main($params, &$ajaxObj) {
	
			// Определяем какой-ajax запрос к нам пришел
		switch ($GLOBALS['_GET']['event']){
		
				//////////////////////////////////////////////////////////// 
				// Обновить светафор+данные о том, что зарег. в системе
			case 'reloadsemafor':

				$content = new tx_infoblock_additionalToolbarIcons;
				$html = $content->htmlBlockInformation();
				$ajaxObj->addContent('tree', $html); // . rand(1,30)
			
			break;
			
				//////////////////////////////////////////////////////////// 
				// Просканировать на предмет ошибок
			case 'scanerror':
				
				$scan = new tx_infoblock_scanerror;
				$html = $scan->main(); 
				$ajaxObj->addContent('tree', $html); // . rand(1,30)
			
			break;
			
				//////////////////////////////////////////////////////////// 
				// Если производится включение/выключение режима отладки
			case 'reload-debuggingmode':
				
					// Узнаем чему равен флаг в настрйках UC
				$flag_debug_mode = t3lib_befunc::getRecord('be_users', $GLOBALS['BE_USER']->user['uid'] , "*"); 
				if ($flag_debug_mode['ext_infoblock_flag_debug_mode'] == 0) $savevalue = 1; else $savevalue = 0;
				
					// Вписываем новое значение (противоположное) значение
				$GLOBALS['TYPO3_DB']->sql_query('
					UPDATE be_users SET ext_infoblock_flag_debug_mode="'.$savevalue.'" 
					WHERE uid = ' . $GLOBALS['BE_USER']->user['uid']
				);
				
					// Переписываем значение для user
				$content = new tx_infoblock_additionalToolbarIcons;
				$html = $content->htmlBlockButton();
				$ajaxObj->addContent('tree', $html); // . rand(1,30)
				
			break;
			
				//////////////////////////////////////////////////////////// 
				// Если запущен компилятор
			case 'reload-runcompiler':
				
					// Замеряем время работя скрипта
				$start = microtime(true);
				
					// Запускаем копилятор накопителей на основе TS-описания
				$html = tx_infoblock_user_tcamanipulate_dynamic_compiler_TS::tableTCAcompiler_main();
				
					// Замеряем время работя скрипта
				$time = microtime(true) - $start;
				
				$html = 'Успешно выполнено: <br /><br />' . implode(";<br>" , $html) . ".";
				$html .= "<br /><br />" . ('Скрипт выполнялся '.round($time,3).' сек.');
				$ajaxObj->addContent('tree', $html); // . rand(1,30)
			
			break;
		
		}
	}
}

/* ВСЕ ЭТО МЫ НЕ ВЫВОДИМ ЕСЛИ РАБОТАЕТ AJAX */
IF (!strstr($GLOBALS['_SERVER']['SCRIPT_NAME'], "ajax.php")):

	$_REL_PATH = t3lib_extMgm::extRelPath('air_table')."toolbar/";
	$TYPO3backend->addJavascriptFile($_REL_PATH.'js.ajax_function.js'); //обновление панели по нажатию на кнопку обновить/проверить
	$TYPO3backend->addJavascriptFile($_REL_PATH.'js.menu_item.js');
	$TYPO3backend->addCss('
		#t3infoblock-links-menu li .t3infoblock-hidden {
			display: none;
			z-index: 1000 !important;
		}
		#t3infoblock-links-menu {
			width:60px;
		}
		#t3infoblock-links-menu .toolbar-item-active {
			background-image:url('.$_REL_PATH.'icons/toolbar_item_active_bg_60.png);
		}
	');
	$TYPO3backend->addToolbarItem('tx_infoblock_additionalToolbarIcons', 'tx_infoblock_additionalToolbarIcons');

ENDIF;

?>
